<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsAddress extends JPlugin
{
	var $fieldNames = array(
		'addressee', 'address', 'state',
		'city', 'zip', 'country', 'telephone',
		'fax', 'mobile', 'icq', 'msn', 'aol',
		'skype', 'google', 'latitude', 'longitude',  
		'ym'
	);
	
	
	var $_firstFive = array(
		'address', 'state', 'city', 'zip', 'country'
	);
	
	var $fields;
	
	function plgJoomsuite_content_fieldsAddress( &$subject, $params ) {
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'address') return;

		
		$this->fParams = &$params;
		$default = $this->fetchFields($obj, $params);
		
		// The values with JUser field values by default.
		$firstFiveValues = $this->_getPairedData($this->_firstFive, $default, false);
		
		$otherFields = array_diff($this->fieldNames, $this->_firstFive, array('addressee'));
		
		echo '<table cellpadding="3" cellspacing="0" border="0">';
		
		if($this->isVisible('addressee')){
			?>
			<tr>
				<td><?php echo JText::_('Person'); ?></td>
				<td colspan="3"><input type="text" size="70" name="fields[<?php echo $obj->id; ?>][addressee]" value="<?php echo htmlspecialchars($this->__(@$default['addressee']), ENT_QUOTES, 'UTF-8'); ?>" /></td>
			</tr>
			<?php
		}
		
		foreach ($firstFiveValues as $v) {
			echo '<tr>';
			foreach ($v as $key => $val) {
				echo '<td>', JText::_(ucfirst( $key )), '</td>';
				echo '<td><input type="text" size="20" name="fields[', $obj->id, '][', $key,']" value="', htmlspecialchars($val, ENT_QUOTES, 'UTF-8'), '"/></td>';
			}
			echo '</tr>';
		}
		
		foreach ($otherFields as $key) {
			if (!$this->isVisible($key))
				continue;
			echo '<tr>';
			echo '<td>', JText::_(ucfirst( $key )), '</td>';
			$val = $this->__(@$default[ $key ]);
			echo '<td colspan="3"><input type="text" size="70" name="fields[', $obj->id, '][', $key,']" value="', htmlspecialchars($val, ENT_QUOTES, 'UTF-8'), '"/></td>';
			echo '</tr>';
		}
			
	 	echo '</table>';
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'address') return;
		if(!$value) return;
		
		$this->fParams = &$params;
		$error = true;
		if ($this->isVisible('latitude') && !empty($value['latitude']) && !is_numeric($value['latitude'])) {
			JError::raiseWarning('', JText::_('Latitude must be a decimal'), '');
			return;
		}
		if ($this->isVisible('longitude') && !empty($value['longitude']) && !is_numeric($value['longitude'])) {
			JError::raiseWarning('', JText::_('Longitude must be a decimal'), '');
			return;
		}
		
		if (empty($value['latitude']) || empty($value['longitude']))
		{	
			$base_url = "http://maps.google.com/maps/geo?output=csv&key=". $params->get('google_map_key');
			
			$locators = array(
				'address', 'city', 'state', 'zip', 'country'
			);
			
			$address = array();
			foreach ($locators as $l) {
				if (!empty($value[ $l ]))
					$address [] = $value[ $l ]; 
			}
			
			$request_url = $base_url . "&q=" . rawurlencode(implode(', ', $address));
			$csv = file_get_contents($request_url);
			
			if ($csv)
			{
				$csvSplit 	= explode(",", $csv);
				$status 	= $csvSplit[0];
				if ($status == "200") {
					$lat = $csvSplit[2];
					$lng = $csvSplit[3];
					
					$value['latitude'] = $lat;
					$value['longitude'] = $lng;
				}
			}
		}
		
		$error = false;
		$value = serialize($value);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if ($field->type != 'address') return;
		if (!$field->field_value) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		
		$data = array();
		$data = unserialize($field->field_value);
		
		$this->fParams = & $params;

		if(count($data) <= 0 ) 
			return;
			
		foreach ($data as $k => $v) {
			$data[ $k ] = htmlspecialchars( $v, ENT_QUOTES, 'UTF-8' );
		}
			
		if($this->isVisible('addressee') && @$data['addressee'])
		{
			$out[] = sprintf('<tr><td><b>%s:</b></td><td colspan=3>%s</td></tr>',
			JText::_('Addressee'), $data['addressee'] ?  $data['addressee'] : JText::_('n/a'));
		}
		
		$firstFive = $this->_getPairedData($this->_firstFive, $data);
		
		foreach ($firstFive as $row) {
			$vals = array();

			foreach ($row as $k => $v)
				$vals[] =  '<td><b>'.JText::_(ucfirst($k)).':</b></td><td>'.$v.'</td>';
			if (count($vals) < 2)
				$vals[] = '<td colpsan="3">&nbsp;</td>';
				
			$out[] = '<tr>'.implode("\n", $vals).'</tr>'; 
		}
		
		if(	($this->isVisible('telephone') && @$data['telephone']) ||
		($this->isVisible('fax') && @$data['fax']) ||
		($this->isVisible('mobile') && @$data['mobile']) )
		{
			$out[] = '<tr><td></b></td><td colspan=3>&nbsp;</td></tr>';
		}
		if($this->isVisible('telephone') && @$data['telephone'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(
			JURI::base().'/components/com_resource/images/icons/tel_office.png',
			'telephone icon', array('align' => 'absmiddle')) : '',
			JText::_('Telephone'), $data['telephone']);
		}
		if($this->isVisible('fax') && @$data['fax'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/tel_fax.png',
			'telephone icon', array('align' => 'absmiddle')):'',
			JText::_('Fax'), $data['fax']);
		}
		if($this->isVisible('mobile') && @$data['mobile'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/tel_cellular.png',
			'telephone icon', array('align' => 'absmiddle')):'',
			JText::_('Mobile'), $data['mobile']);
		}
		if(	($this->isVisible('telephone') && @$data['telephone']) ||
		($this->isVisible('fax') && @$data['fax']) ||
		($this->isVisible('mobile') && @$data['mobile']) )
		{
			$out[] = '<tr><td></b></td><td colspan=3>&nbsp;</td></tr>';
		}
		if($this->isVisible('msn') && @$data['msn'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_msn.gif',
			'MSN icon', array('align' => 'absmiddle')):'',
			JText::_('MSN'), $data['msn']);
		}
		if($this->isVisible('icq') && @$data['icq'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_icq.gif',
			'icq icon', array('align' => 'absmiddle')):'',
			JText::_('ICQ'), $data['icq']);
		}
		if($this->isVisible('skype') && @$data['skype'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3><a href="skype:%s">%s</a></td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_skype.gif',
			'skype icon', array('align' => 'absmiddle')):'',
			JText::_('Skype'), $data['skype'], $data['skype']);
		}
		if($this->isVisible('ym') && @$data['ym'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_ym.gif',
			'ym icon', array('align' => 'absmiddle')):'',
			JText::_('Yahoo'), $data['ym']);
		}
		if($this->isVisible('aol') && @$data['aol'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_aol.gif',
			'aol icon', array('align' => 'absmiddle')):'',
			JText::_('AOL'), $data['aol']);
		}
		if($this->isVisible('google') && @$data['google'])
		{
			$out[] = sprintf('<tr><td nowrap><b>%s %s:</b></td><td colspan=3>%s</td></tr>',
			$params->get('icons') ? JHTML::image(JURI::base().
			'/components/com_resource/images/icons/im_google.gif',
			'google icon', array('align' => 'absmiddle')):'',
			JText::_('Google'), $data['google']);
		}
		
		$showLatitude = $params->get('show_latitude') && $this->isVisible('latitude') && @$data['latitude'];
		$showLongitude = $params->get('show_longitude') && $this->isVisible('longitude') && @$data['longitude'];
		
		if ($showLatitude || $showLongitude)
			$out[] = '<tr><td colspan="4">&nbsp;</td></tr>';
		
		if ($showLongitude)
			$out[] = '<tr><td nowrap><b>'.JText::_('Latitude').':</b></td><td colspan=3>'.$data['latitude'].'</td></tr>';
		
		if ($showLatitude)
			$out[] = '<tr><td nowrap><b>'.JText::_('Longitude').':</b></td><td colspan=3>'.$data['longitude'].'</td></tr>';
		
		if ($params->get('google_map') && 
			(
				($this->isVisible('country') && $this->isVisible('city') && isset($data['country'], $data['city']) && strlen($data['country']) && strlen($data['city'])) 
				||
				(isset($data['longitude'], $data['latitude']) && strlen($data['longitude']) && strlen($data['latitude']))
			)
		)
		{	
			$placeholder = "<tr><td colspan=\"4\">%s</td></tr>";

			$gMapUrl = JURI::root()."plugins/joomsuite_content_fields/addressiframe.php?google_map_key=".$params->get('google_map_key').
				"&map_type=".$params->get('map_type').
				"&zoom=".$params->get('zoom_level', 9).
				"&controls=".$params->get('show_controls', 1).
				"&show_marker=".$params->get('show_marker').
				"&country=".@$data['country'].
				"&city=".@$data['city'].
				"&state=".@$data['state'].
				"&address=".(@$data['address'] ? @$data['address'] :'').
				"&map_width=".$params->get('google_map_width').
				"&map_height=".$params->get('google_map_heigth');
			
			foreach ($this->fieldNames as $name) {
				if ($this->showInGMap($name)){
					$gMapUrl .= '&show['.$name.']='.@$data[$name];
					$gMapUrl .= '&lang['.$name.']='.JText::_(@$name);
				}
			}
			
			if (isset($data['longitude'], $data['latitude']))
				$gMapUrl .= '&longitude='.@$data['longitude'].'&latitude='.@$data['latitude'];
			
			if (!$params->get('show_latitude'))
				$gMapUrl .= '&hideLatitude=1';	
			if (!$params->get('show_longitude'))
				$gMapUrl .= '&hideLongitude=1';
				

			/// Where to display googlemap
			$googleMapDisplay 	= $params->get('google_map_display', 'article');
			$isArticleView 		= !!JRequest::getInt('article');
			
			
			$showGMap = true;
			
			if ($googleMapDisplay == "no")
				$showGMap = false;
			else 
			{
				if ($googleMapDisplay == "intro" 	&& $isArticleView)
					$showGMap = false;
					
				if ($googleMapDisplay == "article" 	&& !$isArticleView)
					$showGMap = false;
			}
				
			if ($showGMap)
			{
				$local = '';
				
				if ($params->get('google_map_as_link')) {
					$placeholder = "<tr><td><b>".JText::_('Google map').":</b></td><td colspan='3'>%s</td></tr>";
					switch ($params->get('google_map_as_link')) {
						case 1: // open in parent window
							$local = '<a title="'.JText::_('Click to see Google Map').'" href="'.$gMapUrl.'">'.JText::_('Google Map').'</a>';
							break;
						case 2: // open in new window
							$local = '<a target="_blank" title="'.JText::_('Click to see Google Map').'" href="'.$gMapUrl.'">'.JText::_('Google Map').'</a>';
							break;
						case 3: //open in ShadowBox
							$this->inijs('shbox');
							$local = "<a rel='shadowbox; width=".($params->get('google_map_width') + 2)."; height=".($params->get('google_map_heigth') + 2)."' title='".JText::_('Google Map')."' href='".$gMapUrl."'>".JText::_('Google Map')."</a>";
							break;
						case 4: //open in SqueezeBox
							$this->inijs('squeeze');
							$local = "<a class='sqbox' rel='{handler: \"iframe\", size: {x:".($params->get('google_map_width') + 2).",y:".($params->get('google_map_heigth') + 2)."}}' title='".JText::_('Google Map')."' href='".$gMapUrl."'>".JText::_('Google Map')."</a>";
							break;
					}
				}
				else {
					$local = "<iframe src='".$gMapUrl."' scrolling='no' style=\"width:".
						($params->get('google_map_width') + 2)."px; height:".($params->get('google_map_heigth') + 2)."px;\" frameborder=\"0\" marginwidth=\"0\" marginheight=\"0\"></iframe>";
				}
				
				$out[] = sprintf($placeholder, $local);
			}
			
			
		}

		if (!empty($out))
			$out = '<table cellpadding="1" cellspacing="1" border="0">'.implode("\n", $out).'</table>';
	}	
	
	/**
	 * Fetches the field values from JUser field mapping
	 * @param $obj
	 * @param JParameter $params
	 * @return array
	 */
	function fetchFields(&$obj, &$params) {
		$default = array();
		$def = JRequest::getVar('fields', null, 'default', 'array');
		
		if (is_array($def[$obj->id])) 
			$default = $def[$obj->id];

		if ($obj->field_value && !count($default)) 
			$default = unserialize($obj->field_value);
			
		if (!count($default)) {
			foreach ($this->fieldNames as $name) {
				$default[ $name ] = '';
			}
		}
		
		$user = & JFactory::getUser();
		if ($this->pingJUser() && $user->get('id')) {
			// The fields to query.
			$fid = array();
			foreach ($this->fieldNames as $k) {
				$info = $params->get( $k );
				if ($info && is_array($info) && $info[ 0 ] && !empty($info[ 2 ]) && is_numeric($info[ 2 ])) 
					$fid[] = $info[ 2 ];
			}
			
			$jUserData = $this->fetchJUserFieldValues($user->get('id'), $fid);
			
			foreach ($default as $k => $v) {
				$info = $params->get( $k );
				// info[0] = show/hide field
				// info[1] = the JUSER fieldid.
				if ($info && is_array($info) && $info[ 0 ] && !empty($info[ 2 ]) && isset($jUserData[$info[ 2 ]])) { 
					$default[ $k ] = $this->__(@$v, $jUserData[ $info[ 2 ] ]['fvalue']);
				}
			}
		}
			
		return $default;
	}
	
	function fetchJUserFieldValues($userId, $fid) {
		$userId = (int)$userId;
		if (!$userId) {
			JError::raiseWarning('ADR1', JText::_('Bad userid'));
			return null;
		}
		
		if (!is_array($fid))
			$fid = array($fid);
		JArrayHelper::toInteger($fid);
		$fid = array_unique( $fid );
		
		$fields = array();
		$db 	= & JFactory::getDBO();
		$user 	= & JFactory::getUser();
		
		// Get the user's core data
		$default = array();
					
		foreach (array('username', 'name', 'email') as $n) {
			$a = array();
			$a['id'] = ucfirst( $n ); 
			$a['fvalue'] = $user->get($n, '');
			$default[$a['id']] = $a;
		}
		
		$q = 'SELECT f.id, d.fvalue FROM `#__juser_extended_data` d '.
			'LEFT JOIN #__juser_extended_fields f ON f.id = d.field_id '.
			'WHERE d.user_id = '.$userId.(count($fid) ? ' AND f.id IN ('.implode(', ', $fid).')' : '');
		$db->setQuery( $q );
		
		$fields = $db->loadAssocList('id');
		
		foreach ($default as $k => $v) {
			$fields[ $k ] = $v;
		}
		return $fields;
	}
	
	/*
	 * @return The variable, if it is set.
	*/
	function __($var, $default = '') {
		if (isset($var) && !empty($var))
			return $var;
		return $default;
	}
	
	function pingJUser() {
		return JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php');
	}
	
	/**
	 * 
	 * @param $field
	 * @return bool
	 */
	function isVisible($field) {
		$v = $this->fParams->get($field);
		
		if (is_array($v))
			return $v[ 0 ];
		return $v;
	}
	
	
	function showInGMap($field) {
		$v = $this->fParams->get($field);
		if (is_array($v))
			return $v[ 1 ];
		
		return $v;
	}
	
	/**
	 * Filter out the data to pairs.
	 * @param $names
	 * @param $data
	 * @param $ignoreEmpty ingore empty values.
	 * @return array Array of arrays, that hold 2 values each. 
	 */
	function _getPairedData(&$names, &$data, $ignoreEmpty = true) {
		$values = array();
		$i = 0;
		foreach ($names as $k) {
			if ($ignoreEmpty && !@$data[ $k ])
				continue;
			if ($this->isVisible( $k )) {
				$values[$i / 2][ $k ] = $this->__(@$data[ $k ]);
				$i++;
			}
		}
		return $values;
	}
    function inijs($pptype) {
		$document = &JFactory::getDocument();
		static $ini = false;
		static $dis=false;
		$basedomain = JURI::root();
		
		JHTML::_('behavior.mootools');
		
		if ($pptype == "shbox" && JRequest::getVar('format') != 'pdf' && $dis == false)
		{
			
			$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/adapter/shadowbox-base.js");
			$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/shadowbox.js");
			$document->addScriptDeclaration("
					Shadowbox.loadSkin('classic', '".$basedomain."media/mightyextensions/js/shadowbox/build/skin');
					Shadowbox.loadLanguage('en', '".$basedomain."media/mightyextensions/js/shadowbox/build/lang');
					Shadowbox.loadPlayer(['iframe'], '".$basedomain."media/mightyextensions/js/shadowbox/build/player');
					window.onDomReady(function(){
					Shadowbox.init();
					});
			");
			$dis = true;
		}

		if ($pptype == "squeeze" && JRequest::getVar('format') != 'pdf' && $ini == false)
		{
			JHTML::_('behavior.modal','a.sqbox');
			$ini = true;
		}
		
	}
}