<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

class plgJoomsuite_content_fieldsCheckbox extends JPlugin
{
	function plgJoomsuite_content_fieldsCheckbox( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'checkbox') return;
		
		$default = array();
		$values  = explode("\n", trim($params->get('values')));
		if($params->get('sort') == 2) asort($values);
		if($params->get('sort') == 3) rsort($values);

		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def))
		{
			foreach ($def[$obj->id] AS $dval)
			{
				$default[] = base64_decode($dval);
			}
		}
		//echo $obj->field_value; exit;
		if( count($default) <= 0 && $obj->field_value) $default = unserialize($obj->field_value);
		if( count($default) <= 0 ) { $default = explode("\n", trim($params->get('values2'))); }
		settype($default, 'array');
		
		$count = $params->get('column', 1);
		$chb = null;

		$table_style = $params->get('table_style') ? "style=\"".$params->get('table_style')."\"" : '';

		$chb .= "<table {$table_style} cellspacing='2' cellpadding='2' border=0>";
		$i = 0;
		$td_style =  $params->get('td_style') ? "style=\"".$params->get('td_style')."\"" : '';
		foreach ($values AS $value) {
				
			if( $i % $count == 0 ) { $chb .= "<tr>"; $tr = $i + $count; }
			$chb .= "<td {$td_style}>";
			$val = explode($params->get('color_separator', "^"), $value);
			if( @$val[1] ) $color = 'color:'.@$val[1]; else $color = '';
			
			in_array( $value, $default ) ? $select = ' checked=\"checked\" ' : $select = '' ;
			
			$chb .= "<table><tr><td><input type=\"checkbox\" {$select} name=\"fields[{$obj->id}][]\" value=\"".base64_encode($value)."\"></td><td> <span style=\"{$color}\">".JText::_($val[0])."</span></td></tr></table>";
			$chb .= "</td>";
			if( $i % $count == 0 && $i == $tr ) { $chb .= "</tr>"; }
			$i++;
			unset( $select );
		}
		$chb .= "</table>";
		if( $params->get('user_value', 1)){
			echo $this->addNewFieldScript($obj, $params);
			if( $params->get('user_value_ref', 'text') == "text" ){
                $chb .= "<a style='cursor:pointer;' onClick='addNewField".$obj->id."();'>".JText::_($params->get('user_value_label'))."</a>";
            }
            else {
                $chb .= "<input type='button' value='".JText::_($params->get('user_value_label'))."' onclick='addNewField".$obj->id."();'/>";
            }
			$chb .= "<div id='clickReferal$obj->id'></div>";			
		}
		echo $chb;
	}
	
	function addNewFieldScript($obj, $params)
	{		
		$uid = uniqid("_");
		?>
		<script type="text/javascript" charset="UTF-8">
			var myvar<?php echo $uid; ?> = 0;
			function addNewField<?php echo $obj->id; ?>()
			{
				var limit = <?php echo $params->get('user_value_limit', 5); ?>;				
				if( myvar<?php echo $uid; ?> < limit ){
					newText = document.createElement("div");
					newText.innerHTML = "<input type='checkbox' checked='checked' id='checkbox_field_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+"' onClick='deleteField<?php echo $obj->id; ?>(text_value_"+myvar<?php echo $uid; ?>+", checkbox_field_<?php echo $obj->id; ?>_"+myvar<?php echo $uid; ?>+")' /><input type='text' name='fields[<?php echo $obj->id ?>][user_value_" + myvar<?php echo $uid; ?> +"][]' id='text_value_"+myvar<?php echo $uid; ?>+"' />";
					my_div = document.getElementById("clickReferal<?php echo $obj->id; ?>");
					var parentDiv = my_div.parentNode;				
					parentDiv.insertBefore(newText, my_div);  
					myvar<?php echo $uid; ?>++;					
				}				
			}

			function deleteField<?php echo $obj->id; ?>(i, j)
			{
				i.parentNode.removeChild( i );
				j.parentNode.removeChild( j );
				myvar<?php echo $uid; ?>--;				
			}
		</script>
		<?php
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'checkbox') return;
		if(!$value) return;
		$values  = explode("\n", trim($params->get('values')));
		$value_c = array();
		foreach( $value as $key => $v ){
			if( is_string($v) ){
				$value_c[$key] = base64_decode( $v );
			}
		}
		$user_limit = $params->get('user_value_limit', 5);
		$i = 0;
		if( $params->get('user_value', 1) ){
			$user_values = array();			
			foreach($value as $key => $v )
			{				
				if( is_string($key) ) {		
					if( is_array($v) && $i < $user_limit && JString::substr($key, 0, 11) == "user_value_" ){						
						$user_value = trim($v[0]);
						$user_value_lowercase = JString::strtolower($user_value);
						if($user_value_lowercase == "") 
							continue;
							
						$already_exists = false;
						foreach($values as $val){
							if( JString::strtolower(trim($val)) == $user_value_lowercase ){
								$already_exists = true;
								break;
							}
						}
						
						if( !$already_exists ) {
							$values[] = $user_value;
							$value_c[] = $user_value;
						}			
						$i++;
					}
				}
			}
			
			// bring default data and user data together
			if( count($values) )
			{				
				JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');
				// select fields values and insert new user value to params			
				$params->set('values', implode('\n', $values));				
				$tField = & JTable::getInstance('Field', 'Table');				
                $tField->load( $id );				
                $tField->set( "params", $params->toString() );
                $tField->store();		
			}		
		}		
		$value = serialize($value_c);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'checkbox') return;
		if(!$field->field_value) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		$array = unserialize($field->field_value);
		if(!is_array($array)) return;
		
		$params->set('category_id', $category);
		foreach ($array AS $value)
		{
			//$value = base64_decode($value);
			$val = explode($params->get('color_separator', "^"), $value);
			if(@$val[1]) $color = ' style="color:'.@$val[1].'" '; else $color = '';
			$output = "<span{$color}>{$val[0]}</span>";
			$out[] = ResHelper::cleanFilterValue($output, base64_encode($value), $field, $params, $record);
		}
		$s = "";
		switch ($params->get('separator')) {
			case 1:
				$s = "\n<br>";
				break;
			case 2:
				$s = ", ";
				break;

			case 3:
				$s = ", \n<br>";
				break;
			case 4:
				$s = $params->get('csep', '-');
				break;
		}
		$out = implode($s, $out);
	}
	function onFilter($out, $type)
	{
		if($type != 'checkbox') return;
		$out = true;
	}
	function onRenderFilter($get, &$filter, $params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;

		if($filters_type != 'checkbox') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$options = explode("\n", $fparam->get('values'));
		
		if(is_array($options))
		{

			if($fparam->get('sort') == 2) asort($options);
			if($fparam->get('sort') == 3) rsort($options);

			$list = array();
			$where = getFilterWhere($params);
			foreach ($options AS $opt)
			{
				$val = explode($params->get('color_separator', "^"), $opt);
				if($fparam->get('show_number'))
				{
					$db = & JFactory::getDBO();
			
					switch ($params->get('filters_mode', 1))
					{
						case 1:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid = {$category}
							AND fv.field_value LIKE ".$db->Quote('%'.$val[0].'%')."
							{$where}
							#GROUP BY r.id";
							break;
						case 3:
							$category = JRequest::getInt('category_id', $category);
							$ids = ResHelper::getCategoryChildrenIds($category);
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid IN ({$ids})
							AND fv.field_value LIKE ".$db->Quote('%'.$val[0].'%')."
							{$where}
							#GROUP BY r.id";
							break;
						case 2:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND fv.field_value LIKE ".$db->Quote('%'.$val[0].'%')."
							{$where}
							#GROUP BY r.id";
							break;
					}
					//echo $sql;
					if(!key_exists($sql, $results))
					{
						$db->setQuery($sql);
						$num = $db->loadResult();
						$results[$sql] = $num;
					}
					else
					{
						$num = $results[$sql];
					}
						
					if($num > 0) $list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0])." ({$num})");
					//if($num > 0) $val[0] .= " ({$num})";
				}
				else
				{
					$list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0]));					
				}
			}
		
			$get = $list;
			/*
			 $def = $mainframe->getUserStateFromRequest( $option.'content.filter_'.$filters->id.$itemid,
			 'filter_'.$filters->id,	JRequest::getVar('filter_'.$filters->id, false),	'var');

			 $get = JHTML::_('select.genericlist', $list, 'filter'.$filters->id,
			 "onchange=\"document.adminForm.filter_{$filters->id}.value=this.value; document.adminForm.submit();\"", 'value', 'text', $def);
			 */
		}
	}
}