<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsEmail extends JPlugin
{
	function plgJoomsuite_content_fieldsEmail( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'email') return;

		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];

		$user = JFactory::getUser();
		?>
<input type="text" style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id?>]" 
				value="<?php echo ($obj->field_value ? stripslashes($obj->field_value) : ($params->get('user_default') ? $user->get('email'): NULL)) ?>"/>
		<?php
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'email') return;

		if(!$value) return;

		jimport('joomla.utilities.mail');
		if(!JMailHelper::isEmailAddress($value))
		{
			JError::raiseWarning(500, JText::_('Email is not correct'));
			$error = 1;
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;

		if($field->type != 'email') return;

		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;



		$icon = '';
		if($params->get('show_email_icon', 0)) $icon = JHTML::image(JURI::base().
		'/components/com_resource/images/icons/mail.png', 'mail icon', array('align' => 'absmiddle'));


		if($params->get('encode')){
			$email = $field->field_value;
			$field->field_value = '';

			$len = strlen($email);
			for ($i=0;$i<$len;$i++)
			{
				$r = rand(0, 1);
				$field->field_value .= ($r ? "&#" . ord($email{$i}) .';' : $email{$i} );
			}
		}

		if($params->get('show')) $text = $field->field_value; else $text = JText::_('Email');


		$out = $icon.' '.JHTML::link('mailto:'.$field->field_value, $text);
		$params->set('filter_linkage', 2);
		$out = ResHelper::cleanFilterValue($out, base64_encode($email), $field, $params, $record);
	}
	function onFilter($out, $type)
	{
		if($type != 'email') return;
		$out = true;
	}
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		//$sql = false;
		if( $type->type != 'email' ) return;
		if( !$value ) return;

		$sql = "field_value = '{$value}'";
	}

	function onFilterWornLabel(&$label, &$filter, $value, &$params, $category_id)
	{

		if ($filter->type != 'email') return;
		if(!$value) return;

		$len = strlen($value);
		for ($i=0;$i<$len;$i++)
		{
			$r = rand(0, 1);
			$label .= ($r ? "&#" . ord($value{$i}) .';' : $value{$i} );
		}
	}

	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;

		if($filters_type != 'email') return;

		$get = array(); return;

		$itemid = JRequest::getVar('Itemid');
		$db = & JFactory::getDBO();

		$where = getFilterWhere($params);
			
		switch ($params->get('filters_mode', 1))
		{
			case 1:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid = {$category} {$where}
				GROUP BY fv.field_value";
				break;
			case 3:
				$category = JRequest::getInt('category_id', $category);
				$ids = ResHelper::getCategoryChildrenIds($category);
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid IN ({$ids}) {$where}
				GROUP BY fv.field_value";
				break;

			case 2:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				WHERE fv.field_id = {$filter->id} {$where}
				GROUP BY fv.field_value";
				break;
		}

		if($fparam->get('order_by')) $sql .= ' ORDER BY ' . $fparam->get('order_by');

		//echo $sql;
		if(!key_exists($sql, $results))
		{
			//echo 123;
			$db->setQuery($sql);
			$get = $db->loadObjectList();
			$results[$sql] = $get;
		}
		else
		{
			$get = $results[$sql];
		}

		if(is_array($get))
		{
			foreach ($get AS $key => $val)
			{
				$get[$key]->value = base64_encode($val->value);
				$get[$key]->text = $val->value;
			}
		}

		//		echo '<pre>';
		//		var_dump($get);
		//		die;

		//echo $filter->title;
		//print_r($get);
	}
}