<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsFile extends JPlugin
{
    function plgJoomsuite_content_fieldsFile( &$subject, $params )
    {
        parent::__construct( $subject, $params );
        $plugin = JRequest::getWord("pdownload");
        if($plugin == 'file')
        {
            $this->downloadFile();
        }
        require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php');
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

    }

    function onRenderField(&$obj, &$params, $type)
    {
        if($type != 'file') return;

        $def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];

        $file = $params->get('allowed_formats');
        switch($params->get('add_type'))
        {
            case 1:
                echo "<input style=\"width:".$params->get('field_size')."\" type=\"file\" name=\"files[{$obj->id}]\" />";
                break;

            case 2:
                echo '<input type="text" style="width:'.$params->get('field_size').'" name="fields['.$obj->id.']" value="'.$obj->field_value.'" />';
                if($params->get('add_type') == 2) echo '<br>'.JText::_('Insert path based on joomla root.');
                break;
            case 3:
                $filter =  explode(", ", $file);
                ?>
<select style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id; ?>]" class="inputbox" size="1">
                    <?php echo implode("\n", ResViewRecord::files($params->get('directory'), $params, $obj->field_value, $filter));?>
</select>
                <?php
                break;
        }
        if($obj->field_value && ($params->get('add_type') == 1) )
        {
            echo '<br><input type="checkbox" value="1" name="remove['.$obj->id.']" value="'.$obj->field_value.'" />'.JText::_('Remove Current');
            echo " ({$obj->field_value})";
            echo "<input type=\"hidden\" name=\"fields[{$obj->id}]\" value=\"{$obj->field_value}\" />";
        }
        echo '<br>'.JText::_('Allowed formats are')." : $file</span>";


        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        $fileHelper = & JS_File_Helper::getInstance();
    }

    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {
        if($type != 'file') return;

        $db = &JFactory::getDBO();
        $value = $db->getEscaped($value);

        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        if (!empty($_POST['remove'][$id]))
        {
            JFile::delete(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.'file'.DS.$value);
            $value = '';
        }
        
        if (!empty($_FILES['files']['name'][$id]))
        {
            $tmp_name = $_FILES['files']['tmp_name'][$id];
            $ext 	= JString::strtolower(JFile::getExt($_FILES['files']['name'][$id]));
            $name	= JFile::makeSafe(JFile::stripExt(basename($_FILES['files']['name'][$id])));

            if (empty($name))
                $name = uniqid('file_');

            $name 	= $name.'.'.$ext;
            $size	= $_FILES['files']['size'][$id];
            $value 	= $name;
            $exts 	= explode(", ", $params->get('allowed_formats'));

            $folder = RES_GENERAL_UPLOAD.DS.(int)$row->user_id.DS.'file';

            if (!JFolder::exists($folder))
            {
                if(!JFolder::create($folder, 0755))
                {
                    $message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
                    $message .= "<br>Folder: ".$folder;
                    JError::raiseError(403, $message);
                    $error = 1;
                    return;
                }
            }

            if (!in_array($ext, $exts))
            {
                $msg = JText::_("File is not apropriate format");
                $msg .= "<br>File: ".$name;
                $msg .= "<br>Allowed Formats: ".implode(", ", $exts);
                JError::raiseWarning(403, $msg);
                $error = 1;
                return;
            }
            if (($size > $params->get('max') * 1024 * 1024) && $params->get('max'))
            {
                $msg = JText::_("File size exceed allowed");
                $msg .= "<br>File: ".$name;
                $msg .= "<br>Size: ".number_format($size, 0, '', ',');
                $msg .= "<br>Allowed Size: ".number_format(1024 * 1024 * $params->get('max'), 0, '', ',').' B';
                JError::raiseWarning(403, $msg);
                $error = 1;
                return;
            }

            if($params->get('attach'))
            {
                $name = time().'_'.$name;
                $value = $name;
            }

            $dest = $folder.DS.$name;

            if(JFile::exists($dest) && !$params->get('overwrite'))
            {
                $msg = JText::_("This File already Exists");
                $msg .= "<br>File: ".$name;
                JError::raiseWarning(403, $msg);
                $error = 1;
                return;
            }
            //echo $tmp_name.'<br>'.$dest.'<br>'.$value; exit;
            if(!JFile::upload($tmp_name, $dest))
            {
                $msg = JText::_("Could not upload the file");
                $msg .= "<br>File: ".$name;
                JError::raiseError(403, $msg);
                $error = 1;
                return;
            }
        }

    }

    function onArticleAuthorChange(&$records, $newAuthor)
    {
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = JS_File_Helper::getInstance();
        $fileHelper->reassignFilesOld($records, $newAuthor, 'file');
    }

    /**
     * Delete the uploaded files
     * @param $recordIds
     * @return unknown_type
     */
    function onDeleteRecords($recordIds)
    {
        jimport ('joomla.filesystem.file');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, f.params, rv.field_value, r.user_id FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(' , ',$recordIds).') AND f.type = "file"';

        $db->setQuery( $q );
        $recs = $db->loadObjectList();

        foreach ($recs as $rec)
        {
            if (empty($rec->user_id) || empty($rec->record_id) || empty($rec->field_id))
                continue;

            $params = new JParameter($rec->params);
            if ($params->get('add_type') == 1)
            {
                $file = $rec->field_value;
                $file = JPath::clean(RES_GENERAL_UPLOAD. DS.$rec->user_id. DS. 'file' . DS. JFile::makeSafe($file));
                $fileHelper = JS_File_Helper::getInstance();
                $fileHelper->removeFiles($file);
            }
        }
    }

    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
    	if(!$field->field_value) return;
        if($field->type != 'file') return;

        $params = new JParameter($field->params);
        $user = $record->user_id;
        $type = $field->type;

//var_dump($field,$params->get('add_type'));

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        switch ($params->get('add_type'))
        {
            case 1:
                $file   = RES_GENERAL_UPLOAD.DS.$user.DS.'file'.DS.$field->field_value;
                break;
            case 3:
            case 2:
                $file = JPath::clean(JPATH_ROOT.DS.$field->field_value);
                break;
        }


        if(file_exists($file))
        {
            $fileManager = &JSFileManager::getInstance();
            $download = JURI::root().$fileManager->getDownloadUrl($field->id);

            $fileHelper = &JS_File_Helper::getInstance();
            
            if($fileHelper->checkSubscription($field->params, false)){
	            if($params->get('show_name')){
	                $label = basename($field->field_value);
	            }else{
	                $label = $field->title;
	            }
            }else{
            	$label = JText::_($params->get('linkname'));
            }
            $link = JHTML::link($download, $label);
            $out = $link;

            $addition = array();

            if($params->get('show_size'))
            {
                $addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($file));
            }
            if($params->get('show_hits', 1))
            {
                $addition[] = JText::_('Hits').': '.$this->jsGetHits($field->id);
            }
            if($params->get('show_ctime'))
            {
                $addition[] = JText::_('Create Time').': '.strftime(JText::_('%d %b %Y'), filectime($file));
            }
            if(count($addition) > 0) $out .= ' <span class="small js_small">('.implode(" | ", $addition).')</span> ';
        }
    }
    function jsGetHits($id)
    {
        $db = &JFactory::getDBO();

        $sql = "SELECT COUNT(*) FROM #__js_res_download_hits WHERE item_id = '{$id}'";
        $db->setQuery($sql);
        return intval($db->loadResult());
    }
    function jsFormatSize($size)
    {

        $kb = 1024;
        $mgb = $kb * 1024;
        $gb  = $mgb * 1024;
        $trb = $gb * 1024;

        if($size > $trb)
        {
            return number_format($size / $trb, 2, ',', ' ')." Tb";
        }
        elseif($size > $gb)
        {
            return number_format($size / $gb, 1, ',', ' ')." Gb";
        }
        elseif($size > $mgb)
        {
            return number_format($size / $mgb, 0, ',', ' ')." Mb";
        }
        elseif($size > $kb)
        {
            return number_format($size / $kb, 0, ',', ' ')." Kb";
        }
        else
        {
            return $size." B";
        }
    }

    function onDownloadFile($field, $recordValue)
    {
        if($field->type != 'file')
        {
            return;
        }
        $user = &JFactory::getUser();
        $file = $recordValue->field_value;
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $params = new JParameter($field->params);
        if($fileHelper->checkSubscription($field->params))
        {
            switch ($params->get('add_type')){
                case 1:
                    $pathData->path = RES_GENERAL_UPLOAD.DS.$field->user_id.DS.'file'.DS.$file;
                    break;
                case 2:
                case 3:
                    $pathData->path = JPATH_ROOT.DS.$file;
                    break; 
            }
            
            $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
            $pathData->error = null;
        }
        else
        {
        	$planIds = $params->get('viewSp', array());
        	if(!is_array($planIds)) settype($planIds, 'array');
        	$link = JRoute::_("index.php?option=com_jcs&view=jcs&layout=form&id=".implode(',', $planIds)."&Itemid=".$params->get('Itemid'), false);
        	JRequest::setVar('return', base64_encode($link));
        	$pathData->error = JText::_($params->get('alertText', "The file is under subscription"));
        	$pathData->path = null;
        }
        
        return $pathData;

    }
}