<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');
if(! class_exists('ResHelper'))
{
	require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'helper.php');
}
class plgJoomsuite_content_fieldsHtml extends JPlugin
{

	function plgJoomsuite_content_fieldsHtml(&$subject, $params)
	{
		parent::__construct($subject, $params);
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'html') return;
		global $mainframe;
		
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
		if(! strlen($obj->field_value)) $obj->field_value = $params->get('default_value', "");
		$width = $params->get('width', '100%');
		$height = $params->get('height', '300');
		$editor = & JFactory::getEditor($params->get('editor'));
		if($params->get('short') && ! $mainframe->isAdmin())
		{
			$editorParams = array('theme' => 'simple');
			if($params->get('editor') == 'tinymce') $editorParams['mode'] = 'simple';
			echo $editor->display("fields[{$obj->id}]", htmlspecialchars($obj->field_value, ENT_QUOTES, 'UTF-8'), $width, $height, '60', '20', null, $editorParams);
		}
		else
		{
			echo $editor->display("fields[{$obj->id}]", htmlspecialchars($obj->field_value, ENT_QUOTES, 'UTF-8'), $width, $height, '60', '20');
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'html') return;
		if(! $value) return;
		
		$filterGroups =  $params->get('filter_groups');
		$user = & JFactory::getUser();
		// convert to array if one group selected
		if ( (!is_array($filterGroups) && (int) $filterGroups > 0) ) { 
			$filterGroups = array($filterGroups);
		}
		
		$gid	= $user->get( 'gid' );

		if (is_array($filterGroups) && in_array( $gid, $filterGroups ))
		{
			$filterType		= $params->get( 'filter_type' );
			$filterTags		= preg_split( '#[,\s]+#', trim( $params->get( 'filter_tags' ) ) );
			$filterAttrs	= preg_split( '#[,\s]+#', trim( $params->get( 'filter_attritbutes' ) ) );
			switch ($filterType)
			{
				case 'NH':
					$filter	= new JFilterInput();
					break;
				case 'WL':
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 0, 0, 0);  // turn off xss auto clean
					break;
				case 'BL':
				default:
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 1, 1 );
					break;
			}
			$value	= $filter->clean( $value );
		} 
		elseif(empty($filterGroups) && $gid != '25') { 
			// no default filtering for super admin (gid=25)
			$filter = new JFilterInput( array(), array(), 1, 1 );
			$value	= $filter->clean( $value );
		}
		
		//$v = JRequest::getVar('fields', array(), 'post', 'array', JREQUEST_ALLOWRAW);
		//$safeHtmlFilter = & JFilterInput::getInstance(null, null, 1, 1);
		//$value = $safeHtmlFilter->_remove($v[$id]);
		//		$v1 = $safeHtmlFilter->clean($v[$id], 'string');
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'html') return;
		if(! $field->field_value) return;
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		//$field->field_value = stripslashes($field->field_value);
//		global $mainframe;
		$db = JFactory::getDBO();
		if(function_exists('wordSensor')) wordSensor($field->field_value);
		$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		$tagPos = preg_match($pattern, $field->field_value);
		if(! $tagPos)
		{
			$out = $field->field_value;
		}
		else
		{
			list($introtext, $fulltext) = preg_split($pattern, $field->field_value, 2);
			if(JRequest::getWord('view') == 'article')
			{
				// Cut out the intro text
				if($params->get('hide_intro')) $out = $fulltext;
				else $out = $introtext . $fulltext;
			}
			else
			{
				$out = $introtext;
			}
		}
		if(JRequest::getCmd('view') != 'article')
		{
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html'.DS.'html_stripper.php';
			$readMoreText = $params->get('seemore');
			// We the text does not contain a link
			if(! preg_match('/href=[\"\'](.*)[\"\']/', $readMoreText))
			{
				$articleLink = 'index.php?option=com_resource&controller=article&category_id=' . JRequest::getInt('category_id') . '&article=' . $field->record_id . '&Itemid=' . JRequest::getInt('Itemid');
				$clientId = JRequest::getInt('client_id');
				if($clientId)
				{
					$articleLink .= '&client=' . $clientId . '&client=' . urlencode(JRequest::getString('client', '', 'default', JREQUEST_ALLOWRAW));
				}
				if($readMoreText)
				{
					$readMoreText = JHTML::link($articleLink, $readMoreText, array('class' => 'readon'));
				}
			}
			$out = JSHTMLStripper::substr($out, $params->get('length', 0), $readMoreText);
		}
		$pateern = "/<pre>[^\{]*\{([a-zA-Z0-9\:\-_\|]*)\}(.*)<\/pre>/isU";
		preg_match($pateern, $out, $match);
		if(is_array($match))
		{
			$out = preg_replace_callback($pateern, 'jsGeshiHighlite', $out);
		}
		$regex = "/<pre lang=\"([a-zA-Z0-9\-_\|]*)\">(.*)<\/pre>/isU";
		preg_match($regex, $out, $match);
		if(is_array($match))
		{
			$out = preg_replace_callback($regex, 'jsGeshiHighlite', $out);
		}
		$row->text = $out;
		$row->title = $field->title;
		$art_id = JRequest::getInt("article");
		$sql = "SELECT title FROM #__js_res_record WHERE id='$art_id'";
		$db->setQuery($sql);
		$row->title = $db->loadResult($sql);
		$dispatcher = & JDispatcher::getInstance();
		$plugins = $params->get('plugins', 'pagebreak');
		if($plugins)
		{
			settype($plugins, 'array');
			foreach($plugins as $plugin)
			{
    			JPluginHelper::importPlugin('content', $plugin);
				// strict loading of content type plugin - loadmodule to warn rss feed breaking
				if (JRequest::getVar("format") == 'feed' && $plugin == 'loadmodule') continue;
			}
			$dispatcher->trigger('onPrepareContent', array(&$row, &$params, JRequest::getInt('limitstart', 0)));
			$toc = (isset($row->toc)) ? $row->toc : '';
			if($toc) $out = '<div class="article-content">' . $toc . $row->text . '</div>'; else $out = $row->text;
			
			$result = $dispatcher->trigger('onAfterDisplayContent', array(&$row, &$params ));
			foreach ($result AS $r)
			{
				if($r) $out .= $r;
			}
		}
		// $out = geshi_highlight($out, 'php');
	    //$out = stripslashes($out);
	}
}

/*
 * Changelog:
 * 	v1.7.5:
 *  	 	Joomla 1.5.11 compatibility
 */