<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsImage extends JPlugin
{
	function plgJoomsuite_content_fieldsImage( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'image') 
			return;
		
		// Restore the field state from request
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) 
			$obj->field_value = serialize($def[$obj->id]);
		
		if($obj->field_value) 
		{
			$array = '';
			$array = unserialize($obj->field_value);
			if(!$array) 
				$array = array();
		}
		?>
		<script type="text/javascript">
		function  switchImage<?php echo $obj->id; ?>(value){
			document.imagelib<?php echo $obj->id; ?>.src = '<?php echo JURI::root()?>' + value;
		}
		</script>
		<select name="fields[<?php echo $obj->id; ?>][image]" id="fields<?php echo $obj->id; ?>image" 
			class="inputbox" size="1" onkeyup="switchImage<?php echo $obj->id; ?>(this.value);" onchange="switchImage<?php echo $obj->id; ?>(this.value);">
		<option value=""  selected="selected">- Select Image -</option>
		<?php echo @implode("\n", $this->images($params->get('directory'), $params, @$array['image']));?>
		</select>
		<?php
		echo ' '.JHTML::_('list.positions', "fields[$obj->id][position]", @$array['position'], NULL, 0, 0 );
		$imid = "fields{$obj->id}image";
		?>
			<script language="javascript" type="text/javascript">
			if (document.getElementById('adminForm').<?php echo $imid; ?>.options.value!=''){
				jsimg='<?php echo JURI::root()?>' + getSelectedValue( 'adminForm', '<?php echo $imid; ?>' );
			} else {
				jsimg='<?php echo JURI::root()?>images/blank.png';
			}
			document.write('<br><img src=' + jsimg + ' name="imagelib<?php echo $obj->id; ?>" width="80" height="80" border="2" alt="<?php echo JText::_( 'Image Preview' ); ?>" />');
			</script>
			<br />
			<?php if ($params->get('allow_title')): 
				echo JText::_('Image Title:'); ?>  <input type="text"  style="width:230px;" name="fields[<?php echo $obj->id; ?>][image_title]" value="<?php echo stripslashes(@$array['image_title']) ?>" class="inputbox"/>
			<?php endif; ?>
			<br />
			<?php if ($params->get('allow_alt')): 
				echo JText::_('Attribute alt:'); ?>  <input type="text"  style="width:230px;" name="fields[<?php echo $obj->id; ?>][image_alt]" value="<?php echo stripslashes(@$array['image_alt']) ?>" class="inputbox"/>
			<?php endif; ?>
		<?php
	}
	
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'image') return;
		
		$value = serialize($value);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;

		if($field->type != 'image') return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		$options = array();
		$linkbegin = null;
		$linkend = null;
		if($record->client_id)
		{
			$options['client'] = $record->client;
			$options['client_id'] = $record->client_id;
		}
		
	
		
		$image = unserialize($field->field_value);
		
		if ($params->get('bhv_preview') == 1 && JRequest::getVar('view') == 'list')
		{
			$url = MEUrl::link_record($record, JRequest::getInt('category_id'), $options);

			$linkbegin = '<a href="'.$url.'" title="'.$image["image_title"].'">';
			$linkend = '</a>';
		} 
		
		if ( $params->get('allow_alt') == 1) $alt = $image['image_alt']; else $alt = basename($image['image']);
		
		if ($image['image']) {
			$image['image'] = str_replace(DS, '/', $image['image']);
			$out  = $linkbegin;
			$out .= JHTML::image(
				JURI::base().$image['image'], 
				$alt, 
				array(
					'align' => $image['position'], 
					'hspace' => $params->get('img_hspace'), 
					'vspace' => $params->get('img_vspace'), 
					'title' => $image['image_title']
					)
				);
			$out .= $linkend;
		}
		else
			$out=null;
		
	}
	function images($dir, $param, $default)
	{   
		jimport('joomla.filesystem.file');
		
		$dirr = JPath::clean(JPATH_ROOT.DS.$dir);
		if(!is_dir($dirr))
		{
			return "<option>Directory is not a directory ($dirr)</option>";
		}
		if(!is_readable($dirr))
		{
			return "<option>Directory is not readable ($dirr)</option>";
		}
		
		$filter = array('\.gif$','\.png$','\.jpg$','\.jpeg$');
		$filter = implode('|', $filter);
		
		if(!@$out) $out = array(); 
		
		$files = JFolder::files($dirr, $filter, $param->get('subfolder'), true);

		foreach ($files as $file) {
			$file = str_replace(array(JPATH_ROOT.DS, DS), array('', '/'), $file);
			
			if($file == $default) 
				$s = ' selected="selected" '; 
			else 
				$s = '';
			
			$out[] = "<option value=\"$file\"$s>$file</option>";
		}
		
		return $out;

	}
	
}