<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsPasswd extends JPlugin
{
	function plgJoomsuite_content_fieldsPasswd( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'passwd') return;
		$user = JFactory::getUser();

		if($obj->field_value && ($params->get('show_edit', 0) || ($user->gid >= $params->get('allow_view', 25) && $user->gid >= 23))){
			$secret_word = $params->get('secret_word');
			if ($secret_word || !$secret_word == 'joomla!')
			$pass = $secret_word;
			else
			{
				$config =& JFactory::getConfig();
				$pass = $config->getValue( 'config.secret' );
			}
			$value = 'value="'.$this->md5_decrypt($obj->field_value, $pass).'"';
		}
		?>
<input
	type="password" name="fields[<?php echo $obj->id?>]"
	<?php echo $value; ?> autocomplete="off" />
	<?php
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'passwd') return;
		if(!$value) return;
		$secret_word = $params->get('secret_word');
		if ($secret_word || !$secret_word == 'joomla!')
		$pass = $secret_word;
		else
		{
			$config =& JFactory::getConfig();
			$pass = $config->getValue( 'config.secret' );
		}
		$value = $this->md5_encrypt($value, $pass);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'passwd') return;
		if( !$field->field_value ) return;

		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;

		$user = JFactory::getUser();
		
		if(MEAccess::isAdmin() || MEAccess::isAuthor($record->user_id) || ($user->gid >= $params->get('allow_view', 25))){
			$secret_word = $params->get('secret_word');
			if ($secret_word)
				$pass = $secret_word;
			else
			{
				$config =& JFactory::getConfig();
				$pass = $config->getValue( 'config.secret' );
			}
			$out = $this->md5_decrypt($field->field_value, $pass);
		}
		else return;
	}


	//encode - decode passwd
	function get_rnd_iv($iv_len)
	{
		$iv = '';
		while ($iv_len-- > 0) {
			$iv .= chr(mt_rand() & 0xff);
		}
		return $iv;
	}

	function md5_encrypt($plain_text, $password, $iv_len = 16)
	{
		$plain_text .= "\x13";
		$n = strlen($plain_text);
		if ($n % 16) $plain_text .= str_repeat("\0", 16 - ($n % 16));
		$i = 0;
		$enc_text = $this->get_rnd_iv($iv_len);
		$iv = substr($password ^ $enc_text, 0, 512);
		while ($i < $n) {
			$block = substr($plain_text, $i, 16) ^ pack('H*', md5($iv));
			$enc_text .= $block;
			$iv = substr($block . $iv, 0, 512) ^ $password;
			$i += 16;
		}
		return base64_encode($enc_text);
	}

	function md5_decrypt($enc_text, $password, $iv_len = 16)
	{
		$enc_text = base64_decode($enc_text);
		$n = strlen($enc_text);
		$i = $iv_len;
		$plain_text = '';
		$iv = substr($password ^ substr($enc_text, 0, $iv_len), 0, 512);
		while ($i < $n) {
			$block = substr($enc_text, $i, 16);
			$plain_text .= $block ^ pack('H*', md5($iv));
			$iv = substr($block . $iv, 0, 512) ^ $password;
			$i += 16;
		}
		return preg_replace('/\\x13\\x00*$/', '', $plain_text);
	}
}
?>