<?php
/**
 * @fileID: $Id: picture.php 7552 2011-11-29 04:15:40Z kostya $
 * @changedDate: $LastChangedDate: 2011-11-29 11:15:40 +0700 (Вт, 29 ноя 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsPicture extends JPlugin
{
	function plgJoomsuite_content_fieldsPicture( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php';
		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'picture') return;
		$picture = 'jpg, jpeg, png, gif';

		echo "<input type=\"file\" name=\"files[".$obj->id."]\" /> ";

		if($obj->field_value && $obj->field_value != 'def_img')
		{
			echo "<span class=\"small\">";
			echo '<input type="checkbox" value="1" name="remove['.$obj->id.']" value="'.$obj->field_value.'" />';
			echo JText::_('Remove Current')." ({$obj->field_value})";
			echo "<input type=\"hidden\" name=\"fields[$obj->id]\" value=\"$obj->field_value\" /> </span>";
		}

		$authorId = 0;
		if ($obj->record_id)
		{
			JTable::addIncludePath(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'tables');
			$record = & JTable::getInstance('record','Res');
			$record->id = $obj->record_id;
			$record->load();
			$authorId = (int)$record->user_id;
		}

		$fileHelper = & JS_File_Helper::getInstance();

		echo '<br />'.JText::_('Allowed formats are')." : ".${$obj->type};
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'picture') return;

		$db = &JFactory::getDBO();

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		$post = JRequest::get('POST');
		$files = JRequest::get('FILES');

		if(isset($post['remove'][$id]))
		{
			if(JFile::exists(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type.DS.$value))
				JFile::delete(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type.DS.$value);
			if(JFile::exists(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type.DS.'thumbnail_blog'.DS.$value))
				JFile::delete(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type.DS.'thumbnail_blog'.DS.$value);
			if(JFile::exists(RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type.DS.'thumbnail_article'.DS.$value))
				JFile::delete(RES_GENERAL_UPLOAD.DS.DS.$row->user_id.DS.$type.DS.'thumbnail_article'.DS.$value);
				
			$value = '';
		}

		if($files['files']['name'][$id])
		{
			$tmp_name = $files['files']['tmp_name'][$id];
			$ext = strtolower(JFile::getExt($files['files']['name'][$id]));
			$name = JFile::stripExt(($files['files']['name'][$id]));
			if (empty($name))
				$name = uniqid('picture');

			$name = JFile::makeSafe($name).'.'.$ext;

			$size	= (int)($files['files']['size'][$id]/1024);
			$exts 	= array('gif', 'png', 'jpg', 'jpeg');

			if($params->get('attach'))
				$name = time().'_'.$name;
			$name = $row->id.'_'.$id.'_'.$name;
			$value = $db->getEscaped($name);

			$folder = RES_GENERAL_UPLOAD.DS.$row->user_id.DS.$type;
			if (!JFolder::exists($folder))
			{
				if (!JFolder::create($folder, 0755))
				{
					$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
					JError::raiseError(403, $message);
					$error = 1;
					return;
				}
			}

			if (!in_array($ext, $exts))
			{
				$msg = JText::_("File is not apropriate format");
				$msg .= "<br />".JText::_('File').": ".basename($name);
				$msg .= "<br />".JText::_("Allowed Formats").": ".implode(", ", $exts);
				JError::raiseWarning(403, $msg);
				$error = 1;
				return;
			}

			if (($size > $params->get('max')) && $params->get('max'))
			{
				$msg = JText::_("File size exceed allowed");
				$msg .= "<br />".JText::_('File').": ".$name;
				$msg .= "<br />".JText::_('Size').": ".number_format($size, 0, '', ',');
				$msg .= "<br />".JText::_("Allowed Size").": ".number_format($params->get('max'), 0, '', ',');
				JError::raiseWarning(403, $msg);
				$error = 1;
				return;
			}


			$dest = $folder.DS.$name;

			if (JFile::exists($dest) && !$params->get('overwrite'))
			{
				$msg = JText::_("This File already Exists"). "<br />".JText::_('File').": ".$name;
				JError::raiseWarning(403, $msg);
				$error = 1;
				return;
			}
			if (!JFile::upload($tmp_name, $dest))
			{
				$msg = JText::_("Could not upload the file");
				$msg .= "<br />".JText::_('File').": ".$name;
				JError::raiseError(403, $msg);
				$error = 1;
				return;
			}

			@chmod($dest, 0644);

			if ($params->get('bresize', 0) == 1)
			{
				$this->imageResize(
				$name, $dest, $params->get('bwidth'), $params->get('bheight'),
				$params->get('bquality'), $folder, $files['files']['type'][$id], 'blog', $params);
			}

			if($params->get('or_resize', 0) == 1)
			{
				$params->set('border', 0);
				$this->imageResize(
				$name, $dest, $params->get('or_width'), $params->get('or_height'),
				$params->get('or_quality'), $folder, $files['files']['type'][$id], 'article', $params);
				if($params->get('delete_orig', 0)) {
					JFile::delete($dest);
				}
			}
		}
		if (empty($value) && ($params->get('blank_img') && ($params->get('blank_img') != -1)))
			$value = 'def_img';
	}

	function onArticleAuthorChange(&$records, $newAuthor)
	{
		$fileHelper = &JS_File_Helper::getInstance();

		$additional = array('thumbnail_blog', 'thumbnail_article');
		$fileHelper->reassignFilesOld($records, $newAuthor, 'picture', $additional);
	}

	/**
	 * Cleanup the uploaded files
	 * @param $recordIds
	 * @return unknown_type
	 */
	function onDeleteRecords($recordIds)
	{
		jimport ('joomla.filesystem.file');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		$db = & JFactory::getDBO();

		$q = 'SELECT r.id AS record_id, rv.field_value, r.user_id FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(" , ", $recordIds).') AND f.type = "picture"';

		$db->setQuery( $q );
		$recs = $db->loadObjectList();

		foreach ($recs as $rec)
		{
			if (empty($rec->user_id) || empty($rec->field_value))
				continue;

			$value = $rec->field_value;
			$baseDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$rec->user_id.DS.'picture');

			if (JFile::exists($baseDir.DS.$value))
				JFile::delete($baseDir.DS.$value);

			if (JFile::exists($baseDir.DS.'thumbnail_blog'.DS.$value))
				JFile::delete($baseDir.DS.'thumbnail_blog'.DS.$value);

			if (JFile::exists($baseDir.DS.'thumbnail_article'.DS.$value))
				JFile::delete($baseDir.DS.'thumbnail_article'.DS.$value);
		}
	}

	function inijs($pptype)
	{
		$document = &JFactory::getDocument();
		static $ini = false;
		static $dis=false;
		$basedomain = JURI::root();

		JHTML::_('behavior.mootools');

		if ($pptype == "shbox" && JRequest::getVar('format') != 'pdf' && $dis == false)
		{
			$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/adapter/shadowbox-base.js");
			$document->addScript($basedomain."media/mightyextensions/js/shadowbox/build/shadowbox.js");
			$document->addScriptDeclaration("
					Shadowbox.loadSkin('classic', '".$basedomain."media/mightyextensions/js/shadowbox/build/skin');
					Shadowbox.loadLanguage('en', '".$basedomain."media/mightyextensions/js/shadowbox/build/lang');
					Shadowbox.loadPlayer(['img'], '".$basedomain."media/mightyextensions/js/shadowbox/build/player');

					window.onDomReady(function(){
						Shadowbox.init({
							overlayColor: '#000000',
							counterType: 5,
							counterLimit: 10,
							handleOversize: 'resize',
							player: ['html', 'img'],
							enableKeys: false
						});
					});
			");
			$dis = true;
		}

		if ($pptype == "squeeze" && JRequest::getVar('format') != 'pdf' && $ini == false)
		{
			JHTML::_('behavior.modal','a.sqbox');
			$ini = true;
		}

	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'picture')
			return;
		if(!$field->field_value)
			return;
		$fileManager = JSFileManager::getInstance();
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		$options = array();
		$after = null;
		$linkbegin = null;
		$linkend = null;
		if($record->client_id)
		{
			$options['client'] = $record->client;
			$options['client_id'] = $record->client_id;
		}

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		$diag_msg = $params->get('diag_msg', 0);

		if ($field->field_value == 'def_img' && ($params->get('blank_img') && $params->get('blank_img') != -1))
		{
			$blank_img = $params->get('blank_img');
			$blank_img_path = 'images'.DS.'stories'.DS.$blank_img;

			if (JFile::exists(JPATH_ROOT.DS.$blank_img_path))
				$image = JHTML::image(JURI::root().'images/stories/'.$blank_img, JText::_('Default image'));
			else
			{
				if(!$diag_msg)
					return;

				$image = JText::_('Default image not found!');
			}

			if ($params->get('bhv_blg') == 2 && !JRequest::getWord('article'))
			{
				$url = MEUrl::link_record($record, JRequest::getInt('category_id'), $options);

				$linkbegin = '<a href="'.$url.'">';
				$linkend = '</a>';
			}
		}elseif ( $field->field_value == 'def_img' && ($params->get('blank_img') == -1 || !$params->get('blank_img')))
			return;

		if (!isset($image))
		{
			$document = &JFactory::getDocument();
			$size2 = '';

			$pptype = $params->get('popup_type');

			if(JRequest::getWord('format') == 'pdf')
				return JText::_("Image Protected");

			$file  = RES_GENERAL_UPLOAD.DS.$user.DS.'picture';

			if (JRequest::getWord('view') == 'article' || JRequest::getWord('controller') == 'article')
			{
				$file_orig = $file.DS.$field->field_value;
				$file .= DS.'thumbnail_article'.DS.$field->field_value;
				$size = null;

				if($params->get('or_resize', 0)==0){
					if (JFile::exists($file_orig)){
						$size2 = null;
					}elseif ( JFile::exists($file) ){
						$size2 = 'article';
					}else{

						if (!$diag_msg)
							return;
						$currimg = JText::_('Image not found!');
					}
				}
				else if (!JFile::exists($file))
				{
					if(!$diag_msg)
						return;
					$currimg = JText::_('No image for article view!');
				}
				else
					$size2 = "article";

				$align = $params->get('article_align');
				$ind = null;

				if($align == 'bottom')
					$after = '<br />';

				switch ($params->get('bhv_art'))
				{
					case'1';
					$this->inijs($pptype);
					break;
					case'2';
					$pptype = null;
					break;
				}

				if (!JFile::exists($file_orig) && $pptype)
				{
					$pptype = JText::_("Original size image not found");
				}
			}
			else //show blog view anywhere outside the article

			{
				$file_orig = $file.DS.$field->field_value;
				$file_art_res = $file.DS.'thumbnail_article'.DS.$field->field_value;
				$file .= DS.'thumbnail_blog'.DS.$field->field_value;
				$size = "article";

				if($params->get('bresize', 0)==0)
				{
					if (JFile::exists($file_orig)){
						$size2 = null;
						$size = null;
					}elseif ( JFile::exists($file) ){
						$size2 = 'blog';
					}elseif( JFile::exists($file_art_res) ){
						$size2 = 'article';
					}else{
						if (!$diag_msg)
							return;
						$currimg = JText::_('Image not found!');
					}
				}
				else
				{
					$size2 = "blog";
					if (!JFile::exists($file))
					{
						if (!$diag_msg)
							return;
						$currimg = JText::_('No image for blog view!');
					}
				}

				$align = $params->get('align');
				$ind = 'prv';
				switch ($params->get('bhv_blg'))
				{
					case'1';
					$this->inijs($pptype);
					break;
					case'2';
					$pptype = 'lnk_art';
					break;
					case'3';
					$pptype = null;
					break;
				}
				if (!JFile::exists($file_art_res) && $pptype != 'lnk_art')
				{
					$pptype = null;
					$message = JText::_("Resized file for article not found");
				}
			}

			if ($pptype != 'no')
			{
				$fileManager = new JSFileManager();
				if ($size)
					$size = 'thumbnail_'.$size;
				else
					$size = '';

				$img_url = JURI::root().$fileManager->getDownloadUrl($field->id, array('type'=>$size));
				$title = $params->get('def_title');

				switch($pptype)
				{
					case 'shbox':

						$ovcolor = $params->get('def_ovcolor');
						$galmode = $params->get('galmode');
						if(!$ovcolor) 
							$ovcolor = '#000';
						switch ($galmode)
						{
							case '1';
							$gl = '['.$field->record_id.$ind.']';
							break;
							case '2';
							$gl = '[all]';
							break;
							case '3';
							$gl = null;
							break;
						}
						$linkbegin = '<a href="'.$img_url.'" ';
						$linkbegin .= 'title="'.$title.'" ';
						$linkbegin .= 'class="shadowimage" rel="shadowbox'.$gl.';player=img;';
						$linkbegin .= 'options={overlayColor:\''.$ovcolor.'\'} ">';
						$ptitle = JText::_('Click to Enlarge Picture');
						break;

					case 'squeeze':
						$linkbegin = '<a href = "'.$img_url.'" ';
						$linkbegin .= 'class="sqbox" rel="{handler: \'image\'}"';
						$linkbegin .= ' >';
						$ptitle = JText::_('Click to Enlarge Picture');
						break;

					case 'newwin':
						$linkbegin = '<a title="'.$title.'"href="'.$img_url.'" target="_blank">';
						$ptitle = JText::_('Click to view more');
						break;

					case 'lnk_art':
						$link = JRoute::_(MEUrl::link_record($field->record_id, $category, $options));
						$linkbegin = '<a title="'.JText::_('View More').'" href="'.$link.'">';
						$ptitle = JText::_('Click to view full article');
						break;

					default:
						$linkbegin=null;
						$linkend=null;
						if (isset($message))
							$ptitle = JText::_($message);
						else
							$ptitle = null;
						break;
				}
				if (isset($linkbegin)) $linkend = "</a>";
			}
			else
			$ptitle = null;
			
			if ($size2){
				$hspace = $params->get($size2.'_hspace');
				$vspace = $params->get($size2.'_vspace');
				$size2 = 'thumbnail_'.$size2;
			}else{
				$hspace = $params->get('article_hspace');
				$vspace = $params->get('article_vspace');
			}
			$fileManager = new JSFileManager();
			$image = JURI::root().$fileManager->getDownloadUrl($field->id, array('type'=>$size2));


			if (isset($currimg))
				$image = JText::_($currimg);
			else
			{
				if(!$ptitle) 
					$ptitle = $record->title;
				$image = JHTML::image($image, JText::_($ptitle), array('align'=>$align , 'hspace' => $hspace, 'vspace' => $vspace));
			}
		}
		$image = $linkbegin. $image. $after. $linkend;


		if ($params->get('article_align') == 'absmiddle')
			$image =  "<div style='text-align:center;'>{$image}</div>";
		$out .= $image;
	}

	function imageResize($name, $file, $max_width, $max_height, $quality, $folder, $app, $type = false, $params)
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		if($type) $folder = $folder.DS.'thumbnail_'.$type;

		$file 	= JPath::clean($file);
		$folder = JPath::clean($folder);

		if(!JFolder::exists($folder))
		{
			if(!JFolder::create($folder, 0755))
			{
				JError::raiseWarning(403, JText::_("Cannot Create Folder resizing picture, Please, check upload directory is correct and accessible"));
				return false;
			}
		}

		if(!JFile::exists($file))
		{
			JError::raiseWarning(300, JText::_("Not Exists")," ".$file);
			return false;
		}

		$size = getimagesize($file);
		if(($size[0] <= $max_width) && ($size[1] <= $max_height) && !$params->get('force_resize', 1))
		{
			JError::raiseNotice(01, JText::_('No Resize Needed'));
			if(!JFile::exists($folder.DS.$name))
				JFile::copy($file, $folder.DS.$name);
			return;
		}

		// @todo: move the lib files to media :)
//		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'lib'.DS.'resizeimage.inc.php';
		require_once JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'libraries'.DS.'image_processing'.DS.'resizeimage.inc.php';

		$destFile = $folder.DS.$name;

		$resizer = new JS_Image_Resizer($file);
		//$resizer->chunkGifs = false;
		if ($resizer->error())
		{
			JError::raiseWarning(240, JText::_('Cannot create Image '.$resizer->error()));
			return false;
		}

		if($params->get('border'))
		{
			$border = JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.'borders'.DS.$params->get('border');
			if (file_exists($border))
			{
				$resizer->setBorder($border);
			}
		}

		$resizer->resize_limitwh($max_width, $max_height, JPATH_CACHE.DS.$name);
		$resizer->close();

		JFile::copy(JPATH_CACHE.DS.$name, $destFile);
		JFile::delete(JPATH_CACHE.DS.$name);
		@chmod($destFile, 0644);
	}

	function onDownloadFile($field, $recordValue)
	{
		 
		if($field->type != 'picture')
		{
			return;
		}
		$pathData = new stdClass();
		$fileHelper = &JS_File_Helper::getInstance();
		$user = &JFactory::getUser();
		$file = $field->field_value;
		$dir = RES_GENERAL_UPLOAD.DS.$field->user_id.DS.'picture';
		$pathData->error = null;
		
		$type=JRequest::getWord('type');
		if($type)
		{

			$dir.=DS.$type;
		}

		if($fileHelper->checkSubscription($field->params))
		{
			$pathData->path = $dir.DS.$file;
			$fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
		}
		else
		{
			$pathData->error = JText::_("The file is under subscription");
			$pathData->path = null;
		}

		return $pathData;
	}
}
?>