<?php
// no direct access
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsSelect_simple extends JPlugin
{
	function plgJoomsuite_content_fieldsSelect_simple( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type ){
		if( $type != 'select_simple' ) return;
		$values = explode("\n", $params->get('values') );
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = base64_decode($def[$obj->id]);
		
		$sign_before = $params->get('sign_before');
		$sign_after = $params->get('sign_after');
		$sign_mode = $params->get('sign_mode', 1);
		$unique_name = $obj->id;

		$size = $params->get( 'field_size' ) ? 'style="width:'.$params->get( 'field_size' ).'"' : '';
		//  sorting $values
		if($params->get('sort') == 2) asort( $values );
		if($params->get('sort') == 3) rsort( $values );
		if($params->get('user_value')){
			$values[] = JText::_($params->get('user_value_label'));
		}
		$selected = ( $obj->field_value ? $obj->field_value : $params->get('selected') );
		$opt[] = JHTML::_('select.option', '', "- {$obj->title} -");
		foreach( $values AS $key => $line ){
			if($line == "") continue;
			$val = explode($params->get('color_separator', "^"), $line);
			$opt[] = JHTML::_('select.option', base64_encode($line), ResHelper::translateValue($val[0]));
		}
		if ($sign_before && $sign_mode != 2) echo '<span class="sign_before">'.$sign_before.'</span>';
		echo JHTML::_('select.genericlist', $opt, "fields[{$obj->id}]", $size, 'value', 'text', base64_encode($selected), "fields{$obj->id}");
		if ($sign_after && $sign_mode != 2) echo '<span class="sign_after">'.$sign_after.'</span>';

		if( $params->get("user_value") ) {
			echo " <div style='display:none;' id='fields_".$obj->id."_user_value_container'>".
			JText::_($params->get( "user_value_label" )).": <input type='text' name='fields_extra_{$obj->id}' id='fields".$obj->id."_user_value'>".
			   "</div>";
			$this->renderUserValueScript( $obj );
		}
	}

	function renderUserValueScript( &$obj )
	{
		?>
<script type="text/javascript">		 
		function otherClickListener_<?php echo $obj->id ?>()
		{
			var currField 				= document.getElementById( "fields<?php echo $obj->id; ?>" );
			var currUserValueContainer 	= document.getElementById( "fields_<?php echo $obj->id; ?>_user_value_container" );
			if ( currField.options.length-1 == currField.options.selectedIndex ) {				
				currUserValueContainer.style.display = "block";				
			}else {
              currUserValueContainer.style.display = "none";
            }				
			window.setTimeout( otherClickListener_<?php echo $obj->id; ?>, 100 );
		}
		otherClickListener_<?php echo $obj->id; ?>();
		</script>
		<?php
	}

	function onBeforeSave( &$value, &$params, $type, $id, $row, &$error )
	{
		if( $type != 'select_simple' ) return;
		if( !$value ) return;
		$user_value = JRequest::getVar("fields_extra_{$id}");
		if($params->get('user_value') && $user_value && isset($user_value)){
			$user_value = trim($user_value);
			$user_value_lowercase = JString::strtolower($user_value);
			$values = explode("\n", $params->get('values'));
			$already_exist = false;
			foreach($values AS $v){
				if( JString::strtolower( trim($v) ) == $user_value_lowercase ){
					$already_exist = true;
					break;
				}
			}
			if ( ! $already_exist ) {
				JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_resource/tables/');
				// select fields values and insert new user value to params
				$values[] = $user_value;
				$params->set('values', implode('\n', $values));
				$tField = & JTable::getInstance('Field', 'Table');
				$tField->load( $id );
				$tField->set( "params", $params->toString() );
				$tField->store();
			}
			$value = $user_value;
		} else {
			$value = base64_decode(trim($value));
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if( !$field->field_value ) return;
		if( $field->type != 'select_simple' ) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		$val = explode($params->get('color_separator', "^"), $field->field_value);
		$color = ( @$val[1] ) ? "style='color:{$val[1]}'" : null;
		$output = stripslashes($val[0]);
		$sign_before = $params->get('sign_before');
		$sign_after = $params->get('sign_after');
		$sign_mode = $params->get('sign_mode', 1);
		$out = null;
		
		$params->set('category_id', $category);
		$output = ResHelper::cleanFilterValue($output, base64_encode($field->field_value), $field, $params, $record);
		if ($sign_before && $sign_mode != 3) $out = '<span class="sign_before">'.$sign_before.'</span>&nbsp;';
		$out .= "<span {$color}>{$output}</span>";
		if ($sign_after  && $sign_mode != 3) $out .= '&nbsp;<span class="sign_after">'.$sign_after.'</span>';
	}

	function onFilter($out, $type)
	{
		if($type != 'select_simple') return;
		$out = true;
	}
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		//echo $type;
		if( $type->type != 'select_simple' ) return;
		if( !$value ) return;
		//$sql = false;

		$sql = "field_value = '{$value}'";
	}


	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();
		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;
		$db = & JFactory::getDBO();
			
		if($filters_type != 'select_simple') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$options = explode("\n", $fparam->get('values'));

		#echo "Plugin: ".$params->get('filters_mode')."<br/>";

		if(is_array($options))
		{

			if($fparam->get('sort') == 2) asort($options);
			if($fparam->get('sort') == 3) rsort($options);

			$list = array();
			
			$where = getFilterWhere($params);
			
			foreach ($options AS $opt)
			{
				$val = explode($params->get('color_separator', "^"), $opt);
				$opt = $db->getEscaped(stripslashes($opt));

				if($fparam->get('show_number'))
				{
					switch ($params->get('filters_mode', 1))
					{
						case 1:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid = {$category}
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
						case 3:
							$category = JRequest::getInt('category_id', $category);
							$ids = ResHelper::getCategoryChildrenIds($category);
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND rc.catid IN ({$ids})
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
						case 2:
							$sql = "SELECT COUNT(r.id)
							FROM #__js_res_record AS r
							LEFT JOIN #__js_res_record_values AS fv ON fv.record_id = r.id
							WHERE fv.field_id = {$filter->id}
							AND fv.field_value = '{$opt}'
							{$where}
							#GROUP BY r.id";
							break;
					}
					//echo $sql;
					if(!$sql) return;
					if(!key_exists($sql, $results))
					{
						$db->setQuery($sql);
						$num = $db->loadResult();
						$results[$sql] = $num;
					}
					else
					{
						$num = $results[$sql];
					}
					/*
					 echo "<pre>";
					 print_r($db->_sql);
					 echo "</pre>";
					*/
					if($num > 0) $list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0])." ({$num})");
					//if($num > 0) $val[0] .= " ({$num})";
				}
				else
				{
					$list[] = JHTML::_('select.option', base64_encode($opt), ResHelper::translateValue($val[0]));
				}
			}
			$get = $list;
			/*
			 $def = $mainframe->getUserStateFromRequest( $option.'content.filter_'.$filters->id.$itemid,
			 'filter_'.$filters->id,	JRequest::getVar('filter_'.$filters->id, false),	'var');

			 $get = JHTML::_('select.genericlist', $list, 'filter'.$filters->id,
			 "onchange=\"document.adminForm.filter_{$filters->id}.value=this.value; document.adminForm.submit();\"", 'value', 'text', $def);
			 */
		}
	}
}
?>
