<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsTel extends JPlugin
{
	function plgJoomsuite_content_fieldsTel( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'tel') return;

		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = serialize($def[$obj->id]);

		if($obj->field_value) $data = unserialize($obj->field_value); else
		{
			$data['country'] = '';
			$data['city'] = '';
			$data['tel'] = '';
			$data['ext'] = '';
		}
		$tab[] = '<table border=0 cellpadding="2" cellspacing="0">';
		$tab[] = '<tr>';

		if($params->get('country_code') == 1)
		{
			$tel[] = '';
		}
		if($params->get('country_code') == 2)
		{
			$tab[] = sprintf('<td><input type="text" name="fields[%d][country]" size="3" maxlength="3" '.
				'id="con_%d" onkeyup="res_format_digit(\'con_%d\')" value="%s" /><br><span class="small">%s</span></td>',
			$obj->id, $obj->id, $obj->id, @$data['country'], JText::_('Country')
			);
		}
		if($params->get('city_code'))
		{
			$tab[] = sprintf('<td><input type="text" name="fields[%d][city]" size="3" maxlength="3" '.
				'id="cit_%d" onkeyup="res_format_digit(\'cit_%d\')" value="%s" /><br><span class="small">%s</span></td>',
			$obj->id, $obj->id, $obj->id, @$data['city'], JText::_('City')
			);
		}
		$tab[] = sprintf('<td><input type="text" name="fields[%d][tel]" size="7" maxlength="'.$params->get('maxlen', 7).'" '.
				'id="tel_%d" onkeyup="res_format_digit(\'tel_%d\')" value="%s" /><br><span class="small">%s</span></td>',
		$obj->id, $obj->id, $obj->id, @$data['tel'], JText::_('Telephone')
		);
		if($params->get('extention'))
		{
			$tab[] = sprintf('<td>#<input type="text" name="fields[%d][ext]" size="5" maxlength="5" '.
				'id="ext_%d" onkeyup="res_format_digit(\'extt_%d\')" value="%s" /><br>&nbsp;<span class="small">%s</span></td>',
			$obj->id, $obj->id, $obj->id, @$data['ext'], JText::_('Ext.')
			);
		}

		$tab[] = '</tr>';
		$tab[] = '</table>';

		echo implode("\n", $tab);
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'tel') return;
		if(!$value) return;
		
		IF(!empty($value['country']) ||	!empty($value['city']) || !empty($value['tel']) || !empty($value['ext']))
		{
			$value = serialize($value);
		}
		else
		{
			$value = NULL;
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;


		if(!$field->field_value) return;

		if($type != 'tel') return;

		$params = new JParameter($field->params);
		$user = $record->user_id;
		$tel = @unserialize($field->field_value);
		/*	print "<pre>";
		 print_r($tel);
		 print "</pre>";*/
			
		$out = array();

		if (isset($tel['country']) && $tel['country'])
		{
			$out[] = "+".$tel['country'];
		}
		if (isset($tel['city']) && $tel['city'])
		{
			$out[] = " (".$tel['city'].")";
		}
		if (isset($tel['tel']) && $tel['tel'])
		{
			$out[] = " ".$tel['tel'];
		}
		if (isset($tel['ext']) && $tel['ext'])
		{
			$out[] = " x ".$tel['ext'];
		}
		$out = implode('', $out);
		$params->set('filter_linkage', 2);
		$out = ResHelper::cleanFilterValue($out, base64_encode($field->field_value), $field, $params, $record);
	}
	function onFilterWornLabel(&$label, &$filter, $value, &$params, $category_id)
	{
		if($filter->type != 'tel') return;
		if(!$value) return;
		
		$tel = @unserialize($value);
		$out = array();

		if (isset($tel['country']) && $tel['country'])
		{
			$out[] = "+".$tel['country'];
		}
		if (isset($tel['city']) && $tel['city'])
		{
			$out[] = " (".$tel['city'].")";
		}
		if (isset($tel['tel']) && $tel['tel'])
		{
			$out[] = " ".$tel['tel'];
		}
		if (isset($tel['ext']) && $tel['ext'])
		{
			$out[] = " x ".$tel['ext'];
		}
		$label = implode('', $out);
	}
	function onFilter($out, $type)
	{
		if($type != 'tel') return;
		$out = true;
	}
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		//$sql = false;
		if( $type->type != 'tel' ) return;
		if( !$value ) return;

		$sql = "field_value = '{$value}'";
	}

	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		return;
	}
}