<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

define ('PLG_TEXTAREA_MAX_SYMBOLS', 12336757);
define ('PLG_TEXTAREA_NOTIFICATION_CLR', '#000000');

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsTextarea extends JPlugin
{
	function plgJoomsuite_content_fieldsTextarea( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'textarea') return;		
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
		if( !strlen($obj->field_value) ) $obj->field_value = $params->get('default_value', "");
		$uid = uniqid('plg_txt');
		$notificationId = 'lim_' .$uid;
		
		$maxLength 			= (int)$params->get('maxlen', -1);
		$fNotify			= $params->get('notify', 0) == 1 && $maxLength > 0;
		$notificationText 	= htmlentities(JText::_($params->get('symbols_left_msg')), ENT_QUOTES, 'UTF-8');
	
		$text 				= htmlspecialchars(stripslashes($obj->field_value));
		
		if ($maxLength > 0) {
			$text = JString::substr($text, 0, $maxLength);
		}
		
		// Dimensions:
		$height = trim($params->get('height', ''));
		$width 	= trim($params->get('width', ''));
		
		if (is_numeric($height)) // seems to be in pixels %)
			$height .= 'px';
		if (is_numeric($width))
			$width .= 'px';
		
		$size = ($height && $width) ? 'height:'.$height.';width:'.$width : '';
		
		$symbolsLeft = $maxLength - JString::strlen($obj->field_value);
		$symbolsLeft = $symbolsLeft < 0 ? 0 : $symbolsLeft;
		
		$notificationTextColor = $params->get('symbols_left_msg_color', PLG_TEXTAREA_NOTIFICATION_CLR);
		?>
			<?php if ($fNotify): ?>
			<script language="javascript">
				function plg_textarea_truncate<?php echo $uid; ?>(elem) {
					var maxSize = <?php echo $maxLength; ?>;
					if (elem.value.length > maxSize) {
						elem.value = elem.value.substr(0, maxSize);
					}
					var symbolsLeft = maxSize - elem.value.length;
					symbolsLeft = symbolsLeft < 0 ? 0 : symbolsLeft;
					document.getElementById('<?php echo $notificationId; ?>').innerHTML = '<?php echo $notificationText?>' + ' ' + symbolsLeft;
				}			</script>
			<?php endif; ?>
			<div>
				<?php if ($params->get('bbcode_mode')) : ?>
				<?php
				$doc = & JFactory::getDocument();
				$doc->addScript(JURI::root().'plugins/joomsuite_content_fields/bbeditor.js');
				JHTML::_('behavior.mootools');
				?>
	<script>
	Window.onDomReady(function() {
		var bbEditor = new JS_BB_Editor();
		bbEditor.init('<?php echo $uid; ?>');

		var controls = $$('#<?php echo 'controls_', $uid; ?> input');
		
		controls[ 0 ].addEvent('click', function() {
			bbEditor.doAddTags('[b]', '[/b]');
		});
		controls[ 1 ].addEvent('click', function() {
			bbEditor.doAddTags('[i]', '[/i]');
		});
		controls[ 2 ].addEvent('click', function() {
			bbEditor.doAddTags('[u]', '[/u]');
		});
		controls[ 3 ].addEvent('click', function() {
			bbEditor.doURL();
		});
		controls[ 4 ].addEvent('click', function() {
			bbEditor.doImage();
		});
		controls[ 5 ].addEvent('click', function() {
			bbEditor.doAddTags('[code]', '[/code]');
		});

		var selects = $$('#<?php echo 'controls_', $uid; ?> select');
		
		selects[ 0 ].addEvent('change', function() {
			bbEditor.doFontSize(this.value);
		});
		
		selects[ 1 ].addEvent('change', function() {
			bbEditor.doColor(this.value);
		});
	});
	</script>	
				<div id="controls_<?php echo $uid; ?>">
					<input type="button" value="<?php echo JText::_('[B]'); ?>" class="button" />
					<input type="button" value="<?php echo JText::_('[I]'); ?>" class="button" />
					<input type="button" value="<?php echo JText::_('[U]'); ?>" class="button" />
					<input type="button" value="<?php echo JText::_('[URL]'); ?>" class="button" />
					<input type="button" value="<?php echo JText::_('[IMG]'); ?>" class="button" />
					<input type="button" value="<?php echo JText::_('[CODE]'); ?>" class="button" />
					<label><?php echo JText::_('Font size'); ?>
						<select class="button">
							<option value="1">1</option>
							<option value="2">2</option>
							<option value="3">3</option>
							<option value="4">4</option>
							<option value="5">5</option>
							<option value="6">6</option>
							<option value="7">7</option>
						</select>
					</label>
					<label><?php echo JText::_('Color'); ?>
						<select class="button">
							<option value="red" style="color: red">red</option>
							<option value="orange" style="color: orange">orange</option>
							<option value="yellow" style="color: yellow">yellow</option>
							<option value="green" style="color: green">green</option>
							<option value="blue" style="color: blue">blue</option>
							<option value="violet" style="color: violet">violet</option>
							<option value="black" style="color: black">black</option>
						</select>
					</label>
				</div>
				<?php endif; ?>
				<textarea <?php if ($fNotify): ?>onkeyup="plg_textarea_truncate<?php echo $uid; ?>(this)" <?php endif; ?> 
					id="<?php echo $uid; ?>"  style="<?php echo $size; ?>" cols="50" rows="10" name="fields[<?php echo $obj->id?>]"><?php echo $text; ?></textarea>
				<?php if ($fNotify): ?>
				<br />
					<div id="<?php echo $notificationId; ?>" style="color: <?php echo $notificationTextColor; ?>">
						<?php echo $notificationText, ' ',	$symbolsLeft; ?>
					</div>
				<?php endif; ?>
			</div>
		<?php 
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'textarea') return;
		if(!$value) return;
                
                
                
                $tags = $params->get('allowed_tags', '');
                $tags = explode(',', $tags);
                if(count($tags))
                {
                    $value = $_REQUEST['fields'][$id];
                
                
		$filterInput = &JFilterInput::getInstance($tags, null, 0, 1, 0);
                $value = $filterInput->clean($value);
                }
		// Truncate.
		$maxLength = $params->get('maxlen', 0);
		if ($maxLength > 0) {
			$value = JString::substr($value, 0, $maxLength);
		}
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		if(!$field->field_value) 
			return;
		
		if($type != 'textarea') 
			return;
			
		$params = new JParameter($field->params);
		$user = $record->user_id;
			
		if ($params->get('bbcode_mode')) {
			require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'html'.DS.'bbcodeparser.php';
			$field->field_value = JS_BBCodeParser::bb2html( $field->field_value );
			
			if (JRequest::getCmd('view') != 'article') {
				require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html'.DS.'html_stripper.php';
				
				$field->field_value = JSHTMLStripper::substr($field->field_value, $params->get('length', 0), $params->get('seemore'));
			}
		}
		else {
			if (JRequest::getCmd('view') != 'article' && $params->get('length', 0)) {
				$len = $params->get('length', 0);
				$field->field_value = $field->field_value." ";
		        $field->field_value = JString::substr($field->field_value, 0, $len);
		        $field->field_value = JString::substr($field->field_value, 0, JString::strrpos($field->field_value,' '));
		        $field->field_value = $field->field_value." ".$params->get('seemore', '...');
			}
		}
		
		$field->field_value = str_replace("\n", '<br />', (stripslashes($field->field_value)));
		
		$tagPos = JString::strpos($out, '[READMORE]');
		$chars = 10;

		if($tagPos === false) {
			$out = $field->field_value;
		} 
		else 
		{
			if(JRequest::getWord('view') != 'article')
			{
				$out  =  JString::substr($field->field_value, 0, $tagPos);
				$out .=  JString::substr($field->field_value, ($tagPos + $chars));
			}
			else
			{
				$out =  JString::substr($field->field_value, 0, $tagPos);
			}
		}
	}
}