<?php
// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsUrl extends JPlugin
{
	function plgJoomsuite_content_fieldsUrl( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'url') return;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
	
		?>
			<input type="text"  style="width:<?php echo $params->get('field_size')?>" name="fields[<?php echo $obj->id; ?>]" value="<?php echo stripslashes($obj->field_value) ?>"/>
		<?php
		
		if($params->get('allow_picture'))
		{
			?>
				<input type="file" name="files[<?php echo $obj->id; ?>]" />
			<?php
			
			$user = & JFactory::getUser();
			$user->get('id');
			
			require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
			ResControllerConfig::initialyze ();
		
			$folder = RES_GENERAL_UPLOAD;
			$folder = str_replace(array(JPATH_ROOT.DS, str_replace('\\', '/',JPATH_ROOT.DS)),'', $folder);
			$folder = str_replace('\\','/', $folder);
			$image_path = $folder.'/'.$type.'/'.$user->get('id').'/'.$obj->record_id.'-'.$obj->id.'.jpg';
			if(file_exists($image_path))
			{
				?>
				<span class="small">
				<label>
				<input type="checkbox" value="1" name="remove[<?php echo $obj->id; ?>]" />
				<?php echo JText::_('Remove current'); ?>
				</label>
				</span>
				<?php
			}
			
			echo '<br>'.JText::_('Allowed formats are').' : jpg, gif, png';
			
			require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
			$fileHelper = & JS_File_Helper::getInstance();
			
			$authorId = $fileHelper->getRecordOwner($obj->record_id);
			echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $authorId, '"/>';
		}
	}
	
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'url') return;
		if(!$value) return;
		if (!eregi("^http", $value) && !eregi("^https", $value) && !eregi("^ftp", $value)) 
		{
			$value = 'http://'.$value;
		}
		
		//picture code --- start
		$db = &JFactory::getDBO();
		$value = $db->getEscaped($value);
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();
		
		
		$thumbname = $row->id.'-'.$id.'.jpg';
		//here is thumbnail removing, in case remove check box selected
		if(@$_POST['remove'][$id]){
			JFile::delete(RES_GENERAL_UPLOAD.DS.$type.DS.$row->user_id.DS.$thumbname);
		}
		
		if ($params->get('allow_picture')) 
		{	
			if ($_FILES['files']['name'][$id])
			{
				$tmp_name = $_FILES['files']['tmp_name'][$id];
				$name	= JFile::makeSafe($_FILES['files']['name'][$id]);
			
				$ext 	= JFile::getExt($name);
				$exts 	= array('gif', 'png', 'jpg', 'jpeg','GIF', 'PNG', 'JPG', 'JPEG');
				
				$folder = JPath::clean(RES_GENERAL_UPLOAD.DS.$type.DS.$row->user_id);
				
				if(!JFolder::exists($folder))
				{
					if(!JFolder::create($folder, 0777))
					{
						$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
						JError::raiseError(403, $message);
						$error = 1; return;
					}
				}
				
				if(!in_array($ext, $exts))
				{
					$msg = JText::_("File is not apropriate format");
					$msg .= " : ".basename($name). ' ';
					$msg .= JText::_("Allowed Formats"). ' : '.implode(", ", $exts);
					JError::raiseWarning(403, $msg);
					$error = 1; return;
				}

				$tmp_dest = JPATH_CACHE.DS.uniqid('url_resize_').'.'.JFile::getExt($name);
				if (!JFile::upload($_FILES['files']['tmp_name'][$id], $tmp_dest)) {
					$error = true;
					JError::raiseWarning(403, JText::_('Failed uploading file'));
					return;
				}
	
				$this->imageResize($tmp_dest, $folder.DS.$thumbname, $params->get('upwidth'), $params->get('upheight'), $params->get('upquality'));
				JFile::delete($tmp_dest);
			}
		
			$author = (isset($_REQUEST['fields']['author'][ $id ]) ? (int)$_REQUEST['fields']['author'][ $id ] : -1);
			
			if ($author >= 0 && $row->user_id != $author) {
				if (!JFolder::exists(RES_GENERAL_UPLOAD.DS.$type.DS.$row->user_id))
					JFolder::create(RES_GENERAL_UPLOAD.DS.$type.DS.$row->user_id);
				
				$oldFile = RES_GENERAL_UPLOAD.DS.$type.DS.$author.DS.$thumbname;
				if (JFile::exists($oldFile))
					JFile::move($oldFile, RES_GENERAL_UPLOAD.DS.$type.DS.$row->user_id.DS.$thumbname);
			}
		}
	}
	
	/**
	 * Delete the uploaded files
	 * @param $recordIds
	 * @return unknown_type
	 */
	function onDeleteRecords($recordIds) {
		jimport ('joomla.filesystem.file');
		
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();
		
		$db = & JFactory::getDBO();
		
		$q = 'SELECT r.id AS record_id, r.user_id, f.id as field_id, rv.field_value, f.params FROM '.
			'#__js_res_record r '.
			'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
           	'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
			'WHERE '.
				'r.id IN ('.implode($recordIds).') AND f.type = "url"';
		
		$db->setQuery( $q );
		$recs = $db->loadObjectList();
		
		foreach ($recs as $rec) {
			if (empty($rec->user_id) || empty($rec->record_id) || empty($rec->field_id))
				continue;
			
			$params = new JParameter($rec->params);
			if ($params->get('allow_picture'))
			{
				$file = $rec->record_id.'-'.$rec->field_id.'.jpg';
				$file = JPath::clean(RES_GENERAL_UPLOAD .DS .'url' .DS.$rec->user_id. DS .JFile::makeSafe($file));
				if (JFile::exists($file)) {
					JFile::delete($file);
				}
			}
		}
	}
	
	function imageResize($infile, $outfile, $max_width, $max_height, $quality)
	{
		global $mainframe;
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$infile 	= JPath::clean($infile);
		$outfile 	= JPath::clean($outfile);
		
		// The extension of the resized image file.
		$extension = JString::strtolower(JFile::getExt($infile));
		
		// output folder
		$outFolder = dirname($outfile);
		
		if (!JFolder::exists($outFolder)) {
			if (!JFolder::create($outFolder, 0777))	{
				JError::raiseWarning(403, JText::_("Cannot Create Folder resizing picture, Please, check upload
    				directory is correct and accessible"));
				return false;
			}
		}

		if(!JFile::exists($infile))	{
			JError::raiseWarning('N12343', JText::_("File not exists: ").basename($infile));
			return false;
		}

		$size = getimagesize($infile);

		if(($size[0] > $max_width) && ($size[0] > $size[1]))
		{
			$width  = $max_width;
			$k = $size[0] / $max_width;
			$height = ($size[1] / $k);
		}
		else
		{
			$width  = $size[0];
			$height = $size[1];
		}

		if($height > $max_height)
		{
			$k = $height / $max_height;
			$height = $max_height;
			$width = ($width / $k);
		}

		$width  = round($width);
		$height = round($height);

		switch($extension)
		{
			case "gif":
				$img = imagecreatefromgif($infile);
				break;
			case "png":
				$img = imagecreatefrompng($infile);
				break;
			case "pjpeg":
			case "bmp":
			case "jpeg":
			case "jpg":
				$img = imagecreatefromjpeg($infile);
				break;
		}
		if(!$img)
		{
			JError::raiseWarning(240, JText::_('Cannot create image: '.$infile));
			return ;
		}

		$mini  = imagecreatetruecolor($width, $height);
		$white = imagecolorallocate  ($mini,255,255,255);

		imagefilledrectangle($mini,0,0,$width,$height,$white);
		imagecopyresampled($mini,$img,0,0,0,0,$width,$height,$size[0],$size[1]);

		$tempName = uniqid('myCuteFile');
		@imagejpeg($mini, JPATH_CACHE.DS.$tempName, $quality);
		JFile::copy(JPATH_CACHE.DS.$tempName, $outfile);

		imagedestroy($mini);
		imagedestroy($img);
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		if(!$field->field_value) return;
		if($type != 'url') return;
		
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		// var_dump($field);
		//get thumbnail
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();
		$document = &JFactory::getDocument();
		
		//add align for thumb
		$align = $params->get('align');
		$hspace = $params->get('hspace');
		$vspace = $params->get('vspace');
		$alttext = JText::_($params->get('alttext'));
		
		$folder = RES_GENERAL_UPLOAD;
		$folder = str_replace(array(JPATH_ROOT.DS, str_replace('\\', '/',JPATH_ROOT.DS)),'', $folder);
		$folder = str_replace('\\','/', $folder);
		$image_path = $folder.'/'.$type.'/'.$user.'/'.$field->record_id.'-'.$field->fid.'.jpg';
		$image = JHTML::image($image_path,'', array('align'=>$align , 'hspace' =>$hspace, 'vspace' =>$vspace));
		
		$atr['title'] = $field->field_value;
		$atr['target'] = $params->get( 'target', '_blank' );
		$linktype = $params->get('linktype');
		
		$allow_picture = $params->get('allow_picture');
		
		
		if($params->get('title')) 
			$title = JText::_($params->get('title')); 
		else 
			$title =  $field->field_value;
			
		if($params->get('direct')) 
			$link = $field->field_value; 
		else
			$link = 'index.php?option=com_resource&task=g&link='.$field->id;
		
		$link = JRoute::_($link);
		
		if ($params->get('allow_picture')) 
		{
			if ($alttext) $atr['title'] = $alttext;
			if ($params->get('linktype') == 'pic')
			{
				$out = JHTML::link($link, $image, $atr);
			} 
			else {
				$out = JHTML::link($link, $title, $atr);
				if(file_exists($image_path)){
					$out .= "<br>";
					$out .= JHTML::link($link, $image, $atr);
				}
			}
			
		} 
		else {
			$out = JHTML::link($link, $title, $atr);
		}
		
		if($params->get('show_hits') && !$params->get('direct') )	{
			$db = & Jfactory::getDBO();
			$sql = "SELECT count(*) FROM #__js_res_download_hits WHERE item_id = {$field->id}";
			$db->setQuery($sql);
			$num = (int)$db->loadResult();
			$out .= " (".JText::_('Views').": {$num})"; 
		}
	}
}
?>